/*
 * Faxsuite RESTful API
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 3.0.35
 *
 * Do not edit the class manually.
 *
 */
import {ApiClient} from "../ApiClient";
import {ErrorAuthenticationResponse} from '../model/ErrorAuthenticationResponse';
import {ErrorBadRequestResponse} from '../model/ErrorBadRequestResponse';
import {ErrorInternalServerResponse} from '../model/ErrorInternalServerResponse';
import {ErrorNotFoundResponse} from '../model/ErrorNotFoundResponse';
import {ErrorServiceNotAvailableResponse} from '../model/ErrorServiceNotAvailableResponse';
import {ErrorToManyRequestsResponse} from '../model/ErrorToManyRequestsResponse';
import {Recipients} from '../model/Recipients';

/**
* Recipients service.
* @module api/RecipientsApi
* @version 4.0.0
*/
export class RecipientsApi {

    /**
    * Constructs a new RecipientsApi. 
    * @alias module:api/RecipientsApi
    * @class
    * @param {module:ApiClient} [apiClient] Optional API client implementation to use,
    * default to {@link module:ApiClient#instanc
    e} if unspecified.
    */
    constructor(apiClient) {
        this.apiClient = apiClient || ApiClient.instance;
    }

    /**
     * Callback function to receive the result of the getRecipients operation.
     * @callback moduleapi/RecipientsApi~getRecipientsCallback
     * @param {String} error Error message, if any.
     * @param {module:model/Recipients{ data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * /recipients
     * Description: To obtain a list of recipients
     * @param {Object} opts Optional parameters
     * @param {Number} opts.objectLimit Query parameter to change de default limitation of objects in the result data array (default to <.>)
     * @param {Number} opts.objectOffset Query parameter to change de default offset of objects in the result data array (default to <.>)
     * @param {String} opts.filterJobId Query parameter to fetch after recipient related to specific fax job
     * @param {Boolean} opts.filterSameAccount Query parameter to fetch recipient related to jobs linked to the used token/key for authorization (default to <.>)
     * @param {String} opts.filterFaxNumber Query parameter to fetch recipients after his fax number
     * @param {String} opts.filterFaxNumberNorm Query parameter to fetch recipients after his normed fax number
     * @param {String} opts.filterRecipientReference Query parameter to fetch recipients after his recipient reference
     * @param {String} opts.filterInternationalDialingCode Query parameter to fetch recipients after his international dialing code
     * @param {String} opts.filterResultCode Query parameter to fetch recipients after his result code
     * @param {String} opts.filterResultText Query parameter to fetch recipients after his result text
     * @param {module:model/String} opts.sortField Available sort options for the result data array.
     * @param {module:model/String} opts.sortOrder Describes the order for used sort fields (default to <.>)
     * @param {module:api/RecipientsApi~getRecipientsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {@link <&vendorExtensions.x-jsdoc-type>}
     */
    getRecipients(opts, callback) {
      opts = opts || {};
      let postBody = null;

      let pathParams = {
        
      };
      let queryParams = {
        'objectLimit': opts['objectLimit'],'objectOffset': opts['objectOffset'],'filterJobId': opts['filterJobId'],'filterSameAccount': opts['filterSameAccount'],'filterFaxNumber': opts['filterFaxNumber'],'filterFaxNumberNorm': opts['filterFaxNumberNorm'],'filterRecipientReference': opts['filterRecipientReference'],'filterInternationalDialingCode': opts['filterInternationalDialingCode'],'filterResultCode': opts['filterResultCode'],'filterResultText': opts['filterResultText'],'sortField': opts['sortField'],'sortOrder': opts['sortOrder']
      };
      let headerParams = {
        
      };
      let formParams = {
        
      };

      let authNames = ['ApiAuthKey'];
      let contentTypes = [];
      let accepts = ['application/json'];
      let returnType = Recipients;

      return this.apiClient.callApi(
        '/recipients', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

}